<!DOCTYPE html><html><head>
    <meta charset="utf-8"/>
    <meta name="author" content="Apple Inc."/>
    <meta name="viewport" content="width=device-width initial-scale=1"/>
    
    <a class="dashingAutolink" name="autolink-55"></a><a class="dashAnchor" name="//apple_ref/cpp/Guide/Closures%20%E2%80%94%20The%20Swift%20Programming%20Language%20%28Swift%204.2%29"></a><title>Closures &mdash; The Swift Programming Language (Swift 4.2)</title>
    
    <link rel="license" href="https://docs.swift.org/LICENSE.txt"/>
    <link rel="stylesheet" media="all" href="../_static/stylesheets/application.css"/>
    <link rel="stylesheet" media="all" href="../_static/stylesheets/tspl.css"/>
    <link rel="shortcut icon" sizes="16x16 24x24 32x32 48x48 64x64" type="image/vnd.microsoft.icon" href="../../favicon.ico"/>
    <link rel="apple-touch-icon" href="https://docs.swift.org/apple-touch-icon.png"/>
    <link rel="apple-touch-icon" sizes="57x57" href="https://docs.swift.org/apple-touch-icon-57x57.png"/>
    <link rel="apple-touch-icon" sizes="72x72" href="https://docs.swift.org/apple-touch-icon-72x72.png"/>
    <link rel="apple-touch-icon" sizes="76x76" href="https://docs.swift.org/apple-touch-icon-76x76.png"/>
    <link rel="apple-touch-icon" sizes="114x114" href="https://docs.swift.org/apple-touch-icon-114x114.png"/>
    <link rel="apple-touch-icon" sizes="120x120" href="https://docs.swift.org/apple-touch-icon-120x120.png"/>
    <link rel="apple-touch-icon" sizes="144x144" href="https://docs.swift.org/apple-touch-icon-144x144.png"/>
    <link rel="apple-touch-icon" sizes="152x152" href="https://docs.swift.org/apple-touch-icon-152x152.png"/>
    <link rel="apple-touch-icon" sizes="180x180" href="https://docs.swift.org/apple-touch-icon-180x180.png"/>
    <link rel="mask-icon" href="https://docs.swift.org/assets/images/icon-swift.svg" color="#F05339"/> 
  </head>
  <body>


<nav role="navigation">
    <header role="banner">
      <h1 id="logo">
        <a href="https://swift.org/" title="Swift.org" role="img" aria-label="Swift.org">
          Swift.org
        </a>
      </h1>
    </header>

    <div id="menu-toggle" class="menu-toggle open"></div>

    <h2>The Swift Programming Language<div>Swift 4.2</div></h2>

    <ul>
    <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../index.html">Welcome to Swift</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="TheBasics.html">Language Guide</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="TheBasics.html">The Basics</a></li>
<li class="toctree-l2"><a class="reference internal" href="BasicOperators.html">Basic Operators</a></li>
<li class="toctree-l2"><a class="reference internal" href="StringsAndCharacters.html">Strings and Characters</a></li>
<li class="toctree-l2"><a class="reference internal" href="CollectionTypes.html">Collection Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="ControlFlow.html">Control Flow</a></li>
<li class="toctree-l2"><a class="reference internal" href="Functions.html">Functions</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="Closures.html#">Closures</a></li>
<li class="toctree-l2"><a class="reference internal" href="Enumerations.html">Enumerations</a></li>
<li class="toctree-l2"><a class="reference internal" href="ClassesAndStructures.html">Structures and Classes</a></li>
<li class="toctree-l2"><a class="reference internal" href="Properties.html">Properties</a></li>
<li class="toctree-l2"><a class="reference internal" href="Methods.html">Methods</a></li>
<li class="toctree-l2"><a class="reference internal" href="Subscripts.html">Subscripts</a></li>
<li class="toctree-l2"><a class="reference internal" href="Inheritance.html">Inheritance</a></li>
<li class="toctree-l2"><a class="reference internal" href="Initialization.html">Initialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="Deinitialization.html">Deinitialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="OptionalChaining.html">Optional Chaining</a></li>
<li class="toctree-l2"><a class="reference internal" href="ErrorHandling.html">Error Handling</a></li>
<li class="toctree-l2"><a class="reference internal" href="TypeCasting.html">Type Casting</a></li>
<li class="toctree-l2"><a class="reference internal" href="NestedTypes.html">Nested Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="Extensions.html">Extensions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Protocols.html">Protocols</a></li>
<li class="toctree-l2"><a class="reference internal" href="Generics.html">Generics</a></li>
<li class="toctree-l2"><a class="reference internal" href="AutomaticReferenceCounting.html">Automatic Reference Counting</a></li>
<li class="toctree-l2"><a class="reference internal" href="MemorySafety.html">Memory Safety</a></li>
<li class="toctree-l2"><a class="reference internal" href="AccessControl.html">Access Control</a></li>
<li class="toctree-l2"><a class="reference internal" href="AdvancedOperators.html">Advanced Operators</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../ReferenceManual/AboutTheLanguageReference.html">Language Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../RevisionHistory/RevisionHistory.html">Revision History</a></li>
</ul>

    <li class="toctree-l1 return"><a class="reference internal" href="https://swift.org/">&larr; Return to Swift.org</a></li>
    </ul>
</nav>




<main role="main">
    <article class="page">
        <menu id="bashful" type="toolbar">
          <div class="inner">
            <menuitem id="jump_to" class="menu-bar-item closed">
            <span id="jump_to_toggle">On This Page</span>
            <div class="chevron">
                <div class="chevy chevron-left"></div>
                <div class="chevy chevron-right"></div>
            </div>
            <menu type="list" class="details">
                <ul>
<li><a class="reference internal" href="Closures.html#">Closures</a><ul>
<li><a class="reference internal" href="Closures.html#ID95">Closure Expressions</a><ul>
<li><a class="reference internal" href="Closures.html#ID96">The Sorted Method</a></li>
<li><a class="reference internal" href="Closures.html#ID97">Closure Expression Syntax</a></li>
<li><a class="reference internal" href="Closures.html#ID98">Inferring Type From Context</a></li>
<li><a class="reference internal" href="Closures.html#ID99">Implicit Returns from Single-Expression Closures</a></li>
<li><a class="reference internal" href="Closures.html#ID100">Shorthand Argument Names</a></li>
<li><a class="reference internal" href="Closures.html#ID101">Operator Methods</a></li>
</ul>
</li>
<li><a class="reference internal" href="Closures.html#ID102">Trailing Closures</a></li>
<li><a class="reference internal" href="Closures.html#ID103">Capturing Values</a></li>
<li><a class="reference internal" href="Closures.html#ID104">Closures Are Reference Types</a></li>
<li><a class="reference internal" href="Closures.html#ID546">Escaping Closures</a></li>
<li><a class="reference internal" href="Closures.html#ID543">Autoclosures</a></li>
</ul>
</li>
</ul>

            </menu>
            </menuitem>
          </div>
        </menu>

        
  <div class="section" id="closures">
<h1>Closures<a class="headerlink" href="Closures.html#closures" title="Permalink to this headline"></a></h1>
<p><em>Closures</em> are self-contained blocks of functionality that can be passed around and used in your code. Closures in Swift are similar to blocks in C and Objective-C and to lambdas in other programming languages.</p>
<p>Closures can capture and store references to any constants and variables from the context in which they are defined. This is known as <em>closing over</em> those constants and variables. Swift handles all of the memory management of capturing for you.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Don&rsquo;t worry if you are not familiar with the concept of capturing. It is explained in detail below in <a class="reference internal" href="Closures.html#ID103"><span class="std std-ref">Capturing Values</span></a>.</p>
</div>
<p>Global and nested functions, as introduced in <a class="reference internal" href="Functions.html"><span class="doc">Functions</span></a>, are actually special cases of closures. Closures take one of three forms:</p>
<ul class="simple">
<li>Global functions are closures that have a name and do not capture any values.</li>
<li>Nested functions are closures that have a name and can capture values from their enclosing function.</li>
<li>Closure expressions are unnamed closures written in a lightweight syntax that can capture values from their surrounding context.</li>
</ul>
<p>Swift&rsquo;s closure expressions have a clean, clear style, with optimizations that encourage brief, clutter-free syntax in common scenarios. These optimizations include:</p>
<ul class="simple">
<li>Inferring parameter and return value types from context</li>
<li>Implicit returns from single-expression closures</li>
<li>Shorthand argument names</li>
<li>Trailing closure syntax</li>
</ul>
<div class="section" id="ID95">
<a class="dashingAutolink" name="autolink-49"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Closure%20Expressions"></a><h2>Closure Expressions<a class="headerlink" href="Closures.html#ID95" title="Permalink to this headline"></a></h2>
<p>Nested functions, as introduced in <a class="reference internal" href="Functions.html#ID178"><span class="std std-ref">Nested Functions</span></a>, are a convenient means of naming and defining self-contained blocks of code as part of a larger function. However, it is sometimes useful to write shorter versions of function-like constructs without a full declaration and name. This is particularly true when you work with functions or methods that take functions as one or more of their arguments.</p>
<p><em>Closure expressions</em> are a way to write inline closures in a brief, focused syntax. Closure expressions provide several syntax optimizations for writing closures in a shortened form without loss of clarity or intent. The closure expression examples below illustrate these optimizations by refining a single example of the <code class="docutils literal"><span class="pre">sorted(by:)</span></code> method over several iterations, each of which expresses the same functionality in a more succinct way.</p>
<div class="section" id="ID96">
<h3>The Sorted Method<a class="headerlink" href="Closures.html#ID96" title="Permalink to this headline"></a></h3>
<p>Swift&rsquo;s standard library provides a method called <code class="docutils literal"><span class="pre">sorted(by:)</span></code>, which sorts an array of values of a known type, based on the output of a sorting closure that you provide. Once it completes the sorting process, the <code class="docutils literal"><span class="pre">sorted(by:)</span></code> method returns a new array of the same type and size as the old one, with its elements in the correct sorted order. The original array is not modified by the <code class="docutils literal"><span class="pre">sorted(by:)</span></code> method.</p>
<p>The closure expression examples below use the <code class="docutils literal"><span class="pre">sorted(by:)</span></code> method to sort an array of <code class="docutils literal"><span class="pre">String</span></code> values in reverse alphabetical order. Here&rsquo;s the initial array to be sorted:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">names</span> = [<span class="s">&#34;Chris&#34;</span>, <span class="s">&#34;Alex&#34;</span>, <span class="s">&#34;Ewa&#34;</span>, <span class="s">&#34;Barry&#34;</span>, <span class="s">&#34;Daniella&#34;</span>]
</li></ol></pre></div></div>
<p>The <code class="docutils literal"><span class="pre">sorted(by:)</span></code> method accepts a closure that takes two arguments of the same type as the array&rsquo;s contents, and returns a <code class="docutils literal"><span class="pre">Bool</span></code> value to say whether the first value should appear before or after the second value once the values are sorted. The sorting closure needs to return <code class="docutils literal"><span class="pre">true</span></code> if the first value should appear <em>before</em> the second value, and <code class="docutils literal"><span class="pre">false</span></code> otherwise.</p>
<p>This example is sorting an array of <code class="docutils literal"><span class="pre">String</span></code> values, and so the sorting closure needs to be a function of type <code class="docutils literal"><span class="pre">(String,</span> <span class="pre">String)</span> <span class="pre">-&gt;</span> <span class="pre">Bool</span></code>.</p>
<p>One way to provide the sorting closure is to write a normal function of the correct type, and to pass it in as an argument to the <code class="docutils literal"><span class="pre">sorted(by:)</span></code> method:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">backward</span>(<span class="k">_</span> <span class="nv">s1</span>: <span class="nc">String</span>, <span class="k">_</span> <span class="nv">s2</span>: <span class="nc">String</span>) -&gt; <span class="nc">Bool</span> {
</li><li>    <span class="k">return</span> <span class="nv">s1</span> &gt; <span class="nv">s2</span>
</li><li>}
</li><li><span class="k">var</span> <span class="nv">reversedNames</span> = <span class="nv">names</span>.<span class="nv">sorted</span>(<span class="nv">by</span>: <span class="nv">backward</span>)
</li><li><span class="c">// reversedNames is equal to [&#34;Ewa&#34;, &#34;Daniella&#34;, &#34;Chris&#34;, &#34;Barry&#34;, &#34;Alex&#34;]</span>
</li></ol></pre></div></div>
<p>If the first string (<code class="docutils literal"><span class="pre">s1</span></code>) is greater than the second string (<code class="docutils literal"><span class="pre">s2</span></code>), the <code class="docutils literal"><span class="pre">backward(_:_:)</span></code> function will return <code class="docutils literal"><span class="pre">true</span></code>, indicating that <code class="docutils literal"><span class="pre">s1</span></code> should appear before <code class="docutils literal"><span class="pre">s2</span></code> in the sorted array. For characters in strings, &ldquo;greater than&rdquo; means &ldquo;appears later in the alphabet than&rdquo;. This means that the letter <code class="docutils literal"><span class="pre">&#34;B&#34;</span></code> is &ldquo;greater than&rdquo; the letter <code class="docutils literal"><span class="pre">&#34;A&#34;</span></code>, and the string <code class="docutils literal"><span class="pre">&#34;Tom&#34;</span></code> is greater than the string <code class="docutils literal"><span class="pre">&#34;Tim&#34;</span></code>. This gives a reverse alphabetical sort, with <code class="docutils literal"><span class="pre">&#34;Barry&#34;</span></code> being placed before <code class="docutils literal"><span class="pre">&#34;Alex&#34;</span></code>, and so on.</p>
<p>However, this is a rather long-winded way to write what is essentially a single-expression function (<code class="docutils literal"><span class="pre">a</span> <span class="pre">&gt;</span> <span class="pre">b</span></code>). In this example, it would be preferable to write the sorting closure inline, using closure expression syntax.</p>
</div>
<div class="section" id="ID97">
<h3>Closure Expression Syntax<a class="headerlink" href="Closures.html#ID97" title="Permalink to this headline"></a></h3>
<p>Closure expression syntax has the following general form:</p>
<div class="syntax-outline highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li>{ (<span class="gi">parameters</span>) -&gt; <span class="gi">return type</span> <span class="k">in</span>
</li><li>    <span class="gi">statements</span>
</li><li>}
</li></ol></pre></div></div>
<p>The <em>parameters</em> in closure expression syntax can be in-out parameters, but they can&rsquo;t have a default value. Variadic parameters can be used if you name the variadic parameter. Tuples can also be used as parameter types and return types.</p>
<p>The example below shows a closure expression version of the <code class="docutils literal"><span class="pre">backward(_:_:)</span></code> function from above:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">reversedNames</span> = <span class="nv">names</span>.<span class="nv">sorted</span>(<span class="nv">by</span>: { (<span class="nv">s1</span>: <span class="nc">String</span>, <span class="nv">s2</span>: <span class="nc">String</span>) -&gt; <span class="nc">Bool</span> <span class="k">in</span>
</li><li>    <span class="k">return</span> <span class="nv">s1</span> &gt; <span class="nv">s2</span>
</li><li>})
</li></ol></pre></div></div>
<p>Note that the declaration of parameters and return type for this inline closure is identical to the declaration from the <code class="docutils literal"><span class="pre">backward(_:_:)</span></code> function. In both cases, it is written as <code class="docutils literal"><span class="pre">(s1:</span> <span class="pre">String,</span> <span class="pre">s2:</span> <span class="pre">String)</span> <span class="pre">-&gt;</span> <span class="pre">Bool</span></code>. However, for the inline closure expression, the parameters and return type are written <em>inside</em> the curly braces, not outside of them.</p>
<p>The start of the closure&rsquo;s body is introduced by the <code class="docutils literal"><span class="pre">in</span></code> keyword. This keyword indicates that the definition of the closure&rsquo;s parameters and return type has finished, and the body of the closure is about to begin.</p>
<p>Because the body of the closure is so short, it can even be written on a single line:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">reversedNames</span> = <span class="nv">names</span>.<span class="nv">sorted</span>(<span class="nv">by</span>: { (<span class="nv">s1</span>: <span class="nc">String</span>, <span class="nv">s2</span>: <span class="nc">String</span>) -&gt; <span class="nc">Bool</span> <span class="k">in</span> <span class="k">return</span> <span class="nv">s1</span> &gt; <span class="nv">s2</span> } )
</li></ol></pre></div></div>
<p>This illustrates that the overall call to the <code class="docutils literal"><span class="pre">sorted(by:)</span></code> method has remained the same. A pair of parentheses still wrap the entire argument for the method. However, that argument is now an inline closure.</p>
</div>
<div class="section" id="ID98">
<h3>Inferring Type From Context<a class="headerlink" href="Closures.html#ID98" title="Permalink to this headline"></a></h3>
<p>Because the sorting closure is passed as an argument to a method, Swift can infer the types of its parameters and the type of the value it returns. The <code class="docutils literal"><span class="pre">sorted(by:)</span></code> method is being called on an array of strings, so its argument must be a function of type <code class="docutils literal"><span class="pre">(String,</span> <span class="pre">String)</span> <span class="pre">-&gt;</span> <span class="pre">Bool</span></code>. This means that the <code class="docutils literal"><span class="pre">(String,</span> <span class="pre">String)</span></code> and <code class="docutils literal"><span class="pre">Bool</span></code> types do not need to be written as part of the closure expression&rsquo;s definition. Because all of the types can be inferred, the return arrow (<code class="docutils literal"><span class="pre">-&gt;</span></code>) and the parentheses around the names of the parameters can also be omitted:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">reversedNames</span> = <span class="nv">names</span>.<span class="nv">sorted</span>(<span class="nv">by</span>: { <span class="nv">s1</span>, <span class="nv">s2</span> <span class="k">in</span> <span class="k">return</span> <span class="nv">s1</span> &gt; <span class="nv">s2</span> } )
</li></ol></pre></div></div>
<p>It is always possible to infer the parameter types and return type when passing a closure to a function or method as an inline closure expression. As a result, you never need to write an inline closure in its fullest form when the closure is used as a function or method argument.</p>
<p>Nonetheless, you can still make the types explicit if you wish, and doing so is encouraged if it avoids ambiguity for readers of your code. In the case of the <code class="docutils literal"><span class="pre">sorted(by:)</span></code> method, the purpose of the closure is clear from the fact that sorting is taking place, and it is safe for a reader to assume that the closure is likely to be working with <code class="docutils literal"><span class="pre">String</span></code> values, because it is assisting with the sorting of an array of strings.</p>
</div>
<div class="section" id="ID99">
<h3>Implicit Returns from Single-Expression Closures<a class="headerlink" href="Closures.html#ID99" title="Permalink to this headline"></a></h3>
<p>Single-expression closures can implicitly return the result of their single expression by omitting the <code class="docutils literal"><span class="pre">return</span></code> keyword from their declaration, as in this version of the previous example:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">reversedNames</span> = <span class="nv">names</span>.<span class="nv">sorted</span>(<span class="nv">by</span>: { <span class="nv">s1</span>, <span class="nv">s2</span> <span class="k">in</span> <span class="nv">s1</span> &gt; <span class="nv">s2</span> } )
</li></ol></pre></div></div>
<p>Here, the function type of the <code class="docutils literal"><span class="pre">sorted(by:)</span></code> method&rsquo;s argument makes it clear that a <code class="docutils literal"><span class="pre">Bool</span></code> value must be returned by the closure. Because the closure&rsquo;s body contains a single expression (<code class="docutils literal"><span class="pre">s1</span> <span class="pre">&gt;</span> <span class="pre">s2</span></code>) that returns a <code class="docutils literal"><span class="pre">Bool</span></code> value, there is no ambiguity, and the <code class="docutils literal"><span class="pre">return</span></code> keyword can be omitted.</p>
</div>
<div class="section" id="ID100">
<h3>Shorthand Argument Names<a class="headerlink" href="Closures.html#ID100" title="Permalink to this headline"></a></h3>
<p>Swift automatically provides shorthand argument names to inline closures, which can be used to refer to the values of the closure&rsquo;s arguments by the names <code class="docutils literal"><span class="pre">$0</span></code>, <code class="docutils literal"><span class="pre">$1</span></code>, <code class="docutils literal"><span class="pre">$2</span></code>, and so on.</p>
<p>If you use these shorthand argument names within your closure expression, you can omit the closure&rsquo;s argument list from its definition, and the number and type of the shorthand argument names will be inferred from the expected function type. The <code class="docutils literal"><span class="pre">in</span></code> keyword can also be omitted, because the closure expression is made up entirely of its body:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">reversedNames</span> = <span class="nv">names</span>.<span class="nv">sorted</span>(<span class="nv">by</span>: { <span class="nv">$0</span> &gt; <span class="nv">$1</span> } )
</li></ol></pre></div></div>
<p>Here, <code class="docutils literal"><span class="pre">$0</span></code> and <code class="docutils literal"><span class="pre">$1</span></code> refer to the closure&rsquo;s first and second <code class="docutils literal"><span class="pre">String</span></code> arguments.</p>
</div>
<div class="section" id="ID101">
<h3>Operator Methods<a class="headerlink" href="Closures.html#ID101" title="Permalink to this headline"></a></h3>
<p>There&rsquo;s actually an even <em>shorter</em> way to write the closure expression above. Swift&rsquo;s <code class="docutils literal"><span class="pre">String</span></code> type defines its string-specific implementation of the greater-than operator (<code class="docutils literal"><span class="pre">&gt;</span></code>) as a method that has two parameters of type <code class="docutils literal"><span class="pre">String</span></code>, and returns a value of type <code class="docutils literal"><span class="pre">Bool</span></code>. This exactly matches the method type needed by the <code class="docutils literal"><span class="pre">sorted(by:)</span></code> method. Therefore, you can simply pass in the greater-than operator, and Swift will infer that you want to use its string-specific implementation:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">reversedNames</span> = <span class="nv">names</span>.<span class="nv">sorted</span>(<span class="nv">by</span>: &gt;)
</li></ol></pre></div></div>
<p>For more about operator method, see <a class="reference internal" href="AdvancedOperators.html#ID42"><span class="std std-ref">Operator Methods</span></a>.</p>
</div>
</div>
<div class="section" id="ID102">
<a class="dashingAutolink" name="autolink-50"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Trailing%20Closures"></a><h2>Trailing Closures<a class="headerlink" href="Closures.html#ID102" title="Permalink to this headline"></a></h2>
<p>If you need to pass a closure expression to a function as the function&rsquo;s final argument and the closure expression is long, it can be useful to write it as a <em>trailing closure</em> instead. A trailing closure is written after the function call&rsquo;s parentheses, even though it is still an argument to the function. When you use the trailing closure syntax, you don&rsquo;t write the argument label for the closure as part of the function call.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">someFunctionThatTakesAClosure</span>(<span class="nv">closure</span>: () -&gt; <span class="nc">Void</span>) {
</li><li>    <span class="c">// function body goes here</span>
</li><li>}
</li><li>
</li><li><span class="c">// Here&#39;s how you call this function without using a trailing closure:</span>
</li><li>
</li><li><span class="nv">someFunctionThatTakesAClosure</span>(<span class="nv">closure</span>: {
</li><li>    <span class="c">// closure&#39;s body goes here</span>
</li><li>})
</li><li>
</li><li><span class="c">// Here&#39;s how you call this function with a trailing closure instead:</span>
</li><li>
</li><li><span class="nv">someFunctionThatTakesAClosure</span>() {
</li><li>    <span class="c">// trailing closure&#39;s body goes here</span>
</li><li>}
</li></ol></pre></div></div>
<p>The string-sorting closure from the <a class="reference internal" href="Closures.html#ID97"><span class="std std-ref">Closure Expression Syntax</span></a> section above can be written outside of the <code class="docutils literal"><span class="pre">sorted(by:)</span></code> method&rsquo;s parentheses as a trailing closure:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">reversedNames</span> = <span class="nv">names</span>.<span class="nv">sorted</span>() { <span class="nv">$0</span> &gt; <span class="nv">$1</span> }
</li></ol></pre></div></div>
<p>If a closure expression is provided as the function or method&rsquo;s only argument and you provide that expression as a trailing closure, you do not need to write a pair of parentheses <code class="docutils literal"><span class="pre">()</span></code> after the function or method&rsquo;s name when you call the function:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">reversedNames</span> = <span class="nv">names</span>.<span class="nv">sorted</span> { <span class="nv">$0</span> &gt; <span class="nv">$1</span> }
</li></ol></pre></div></div>
<p>Trailing closures are most useful when the closure is sufficiently long that it is not possible to write it inline on a single line. As an example, Swift&rsquo;s <code class="docutils literal"><span class="pre">Array</span></code> type has a <code class="docutils literal"><span class="pre">map(_:)</span></code> method which takes a closure expression as its single argument. The closure is called once for each item in the array, and returns an alternative mapped value (possibly of some other type) for that item. The nature of the mapping and the type of the returned value is left up to the closure to specify.</p>
<p>After applying the provided closure to each array element, the <code class="docutils literal"><span class="pre">map(_:)</span></code> method returns a new array containing all of the new mapped values, in the same order as their corresponding values in the original array.</p>
<p>Here&rsquo;s how you can use the <code class="docutils literal"><span class="pre">map(_:)</span></code> method with a trailing closure to convert an array of <code class="docutils literal"><span class="pre">Int</span></code> values into an array of <code class="docutils literal"><span class="pre">String</span></code> values. The array <code class="docutils literal"><span class="pre">[16,</span> <span class="pre">58,</span> <span class="pre">510]</span></code> is used to create the new array <code class="docutils literal"><span class="pre">[&#34;OneSix&#34;,</span> <span class="pre">&#34;FiveEight&#34;,</span> <span class="pre">&#34;FiveOneZero&#34;]</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">digitNames</span> = [
</li><li>    <span class="m">0</span>: <span class="s">&#34;Zero&#34;</span>, <span class="m">1</span>: <span class="s">&#34;One&#34;</span>, <span class="m">2</span>: <span class="s">&#34;Two&#34;</span>,   <span class="m">3</span>: <span class="s">&#34;Three&#34;</span>, <span class="m">4</span>: <span class="s">&#34;Four&#34;</span>,
</li><li>    <span class="m">5</span>: <span class="s">&#34;Five&#34;</span>, <span class="m">6</span>: <span class="s">&#34;Six&#34;</span>, <span class="m">7</span>: <span class="s">&#34;Seven&#34;</span>, <span class="m">8</span>: <span class="s">&#34;Eight&#34;</span>, <span class="m">9</span>: <span class="s">&#34;Nine&#34;</span>
</li><li>]
</li><li><span class="k">let</span> <span class="nv">numbers</span> = [<span class="m">16</span>, <span class="m">58</span>, <span class="m">510</span>]
</li></ol></pre></div></div>
<p>The code above creates a dictionary of mappings between the integer digits and English-language versions of their names. It also defines an array of integers, ready to be converted into strings.</p>
<p>You can now use the <code class="docutils literal"><span class="pre">numbers</span></code> array to create an array of <code class="docutils literal"><span class="pre">String</span></code> values, by passing a closure expression to the array&rsquo;s <code class="docutils literal"><span class="pre">map(_:)</span></code> method as a trailing closure:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">strings</span> = <span class="nv">numbers</span>.<span class="nv">map</span> { (<span class="nv">number</span>) -&gt; <span class="nc">String</span> <span class="k">in</span>
</li><li>    <span class="k">var</span> <span class="nv">number</span> = <span class="nv">number</span>
</li><li>    <span class="k">var</span> <span class="nv">output</span> = <span class="s">&#34;&#34;</span>
</li><li>    <span class="k">repeat</span> {
</li><li>        <span class="nv">output</span> = <span class="nv">digitNames</span>[<span class="nv">number</span> % <span class="m">10</span>]! + <span class="nv">output</span>
</li><li>        <span class="nv">number</span> /= <span class="m">10</span>
</li><li>    } <span class="k">while</span> <span class="nv">number</span> &gt; <span class="m">0</span>
</li><li>    <span class="k">return</span> <span class="nv">output</span>
</li><li>}
</li><li><span class="c">// strings is inferred to be of type [String]</span>
</li><li><span class="c">// its value is [&#34;OneSix&#34;, &#34;FiveEight&#34;, &#34;FiveOneZero&#34;]</span>
</li></ol></pre></div></div>
<p>The <code class="docutils literal"><span class="pre">map(_:)</span></code> method calls the closure expression once for each item in the array. You do not need to specify the type of the closure&rsquo;s input parameter, <code class="docutils literal"><span class="pre">number</span></code>, because the type can be inferred from the values in the array to be mapped.</p>
<p>In this example, the variable <code class="docutils literal"><span class="pre">number</span></code> is initialized with the value of the closure&rsquo;s <code class="docutils literal"><span class="pre">number</span></code> parameter, so that the value can be modified within the closure body. (The parameters to functions and closures are always constants.) The closure expression also specifies a return type of <code class="docutils literal"><span class="pre">String</span></code>, to indicate the type that will be stored in the mapped output array.</p>
<p>The closure expression builds a string called <code class="docutils literal"><span class="pre">output</span></code> each time it is called. It calculates the last digit of <code class="docutils literal"><span class="pre">number</span></code> by using the remainder operator (<code class="docutils literal"><span class="pre">number</span> <span class="pre">%</span> <span class="pre">10</span></code>), and uses this digit to look up an appropriate string in the <code class="docutils literal"><span class="pre">digitNames</span></code> dictionary. The closure can be used to create a string representation of any integer greater than zero.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The call to the <code class="docutils literal"><span class="pre">digitNames</span></code> dictionary&rsquo;s subscript is followed by an exclamation mark (<code class="docutils literal"><span class="pre">!</span></code>), because dictionary subscripts return an optional value to indicate that the dictionary lookup can fail if the key does not exist. In the example above, it is guaranteed that <code class="docutils literal"><span class="pre">number</span> <span class="pre">%</span> <span class="pre">10</span></code> will always be a valid subscript key for the <code class="docutils literal"><span class="pre">digitNames</span></code> dictionary, and so an exclamation mark is used to force-unwrap the <code class="docutils literal"><span class="pre">String</span></code> value stored in the subscript&rsquo;s optional return value.</p>
</div>
<p>The string retrieved from the <code class="docutils literal"><span class="pre">digitNames</span></code> dictionary is added to the <em>front</em> of <code class="docutils literal"><span class="pre">output</span></code>, effectively building a string version of the number in reverse. (The expression <code class="docutils literal"><span class="pre">number</span> <span class="pre">%</span> <span class="pre">10</span></code> gives a value of <code class="docutils literal"><span class="pre">6</span></code> for <code class="docutils literal"><span class="pre">16</span></code>, <code class="docutils literal"><span class="pre">8</span></code> for <code class="docutils literal"><span class="pre">58</span></code>, and <code class="docutils literal"><span class="pre">0</span></code> for <code class="docutils literal"><span class="pre">510</span></code>.)</p>
<p>The <code class="docutils literal"><span class="pre">number</span></code> variable is then divided by <code class="docutils literal"><span class="pre">10</span></code>. Because it is an integer, it is rounded down during the division, so <code class="docutils literal"><span class="pre">16</span></code> becomes <code class="docutils literal"><span class="pre">1</span></code>, <code class="docutils literal"><span class="pre">58</span></code> becomes <code class="docutils literal"><span class="pre">5</span></code>, and <code class="docutils literal"><span class="pre">510</span></code> becomes <code class="docutils literal"><span class="pre">51</span></code>.</p>
<p>The process is repeated until <code class="docutils literal"><span class="pre">number</span></code> is equal to <code class="docutils literal"><span class="pre">0</span></code>, at which point the <code class="docutils literal"><span class="pre">output</span></code> string is returned by the closure, and is added to the output array by the <code class="docutils literal"><span class="pre">map(_:)</span></code> method.</p>
<p>The use of trailing closure syntax in the example above neatly encapsulates the closure&rsquo;s functionality immediately after the function that closure supports, without needing to wrap the entire closure within the <code class="docutils literal"><span class="pre">map(_:)</span></code> method&rsquo;s outer parentheses.</p>
</div>
<div class="section" id="ID103">
<a class="dashingAutolink" name="autolink-51"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Capturing%20Values"></a><h2>Capturing Values<a class="headerlink" href="Closures.html#ID103" title="Permalink to this headline"></a></h2>
<p>A closure can <em>capture</em> constants and variables from the surrounding context in which it is defined. The closure can then refer to and modify the values of those constants and variables from within its body, even if the original scope that defined the constants and variables no longer exists.</p>
<p>In Swift, the simplest form of a closure that can capture values is a nested function, written within the body of another function. A nested function can capture any of its outer function&rsquo;s arguments and can also capture any constants and variables defined within the outer function.</p>
<p>Here&rsquo;s an example of a function called <code class="docutils literal"><span class="pre">makeIncrementer</span></code>, which contains a nested function called <code class="docutils literal"><span class="pre">incrementer</span></code>. The nested <code class="docutils literal"><span class="pre">incrementer()</span></code> function captures two values, <code class="docutils literal"><span class="pre">runningTotal</span></code> and <code class="docutils literal"><span class="pre">amount</span></code>, from its surrounding context. After capturing these values, <code class="docutils literal"><span class="pre">incrementer</span></code> is returned by <code class="docutils literal"><span class="pre">makeIncrementer</span></code> as a closure that increments <code class="docutils literal"><span class="pre">runningTotal</span></code> by <code class="docutils literal"><span class="pre">amount</span></code> each time it is called.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">makeIncrementer</span>(<span class="nv">forIncrement</span> <span class="nv">amount</span>: <span class="nc">Int</span>) -&gt; () -&gt; <span class="nc">Int</span> {
</li><li>    <span class="k">var</span> <span class="nv">runningTotal</span> = <span class="m">0</span>
</li><li>    <span class="k">func</span> <span class="nv">incrementer</span>() -&gt; <span class="nc">Int</span> {
</li><li>        <span class="nv">runningTotal</span> += <span class="nv">amount</span>
</li><li>        <span class="k">return</span> <span class="nv">runningTotal</span>
</li><li>    }
</li><li>    <span class="k">return</span> <span class="nv">incrementer</span>
</li><li>}
</li></ol></pre></div></div>
<p>The return type of <code class="docutils literal"><span class="pre">makeIncrementer</span></code> is <code class="docutils literal"><span class="pre">()</span> <span class="pre">-&gt;</span> <span class="pre">Int</span></code>. This means that it returns a <em>function</em>, rather than a simple value. The function it returns has no parameters, and returns an <code class="docutils literal"><span class="pre">Int</span></code> value each time it is called. To learn how functions can return other functions, see <a class="reference internal" href="Functions.html#ID177"><span class="std std-ref">Function Types as Return Types</span></a>.</p>
<p>The <code class="docutils literal"><span class="pre">makeIncrementer(forIncrement:)</span></code> function defines an integer variable called <code class="docutils literal"><span class="pre">runningTotal</span></code>, to store the current running total of the incrementer that will be returned. This variable is initialized with a value of <code class="docutils literal"><span class="pre">0</span></code>.</p>
<p>The <code class="docutils literal"><span class="pre">makeIncrementer(forIncrement:)</span></code> function has a single <code class="docutils literal"><span class="pre">Int</span></code> parameter with an argument label of <code class="docutils literal"><span class="pre">forIncrement</span></code>, and a parameter name of <code class="docutils literal"><span class="pre">amount</span></code>. The argument value passed to this parameter specifies how much <code class="docutils literal"><span class="pre">runningTotal</span></code> should be incremented by each time the returned incrementer function is called. The <code class="docutils literal"><span class="pre">makeIncrementer</span></code> function defines a nested function called <code class="docutils literal"><span class="pre">incrementer</span></code>, which performs the actual incrementing. This function simply adds <code class="docutils literal"><span class="pre">amount</span></code> to <code class="docutils literal"><span class="pre">runningTotal</span></code>, and returns the result.</p>
<p>When considered in isolation, the nested <code class="docutils literal"><span class="pre">incrementer()</span></code> function might seem unusual:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">incrementer</span>() -&gt; <span class="nc">Int</span> {
</li><li>    <span class="nv">runningTotal</span> += <span class="nv">amount</span>
</li><li>    <span class="k">return</span> <span class="nv">runningTotal</span>
</li><li>}
</li></ol></pre></div></div>
<p>The <code class="docutils literal"><span class="pre">incrementer()</span></code> function doesn&rsquo;t have any parameters, and yet it refers to <code class="docutils literal"><span class="pre">runningTotal</span></code> and <code class="docutils literal"><span class="pre">amount</span></code> from within its function body. It does this by capturing a <em>reference</em> to <code class="docutils literal"><span class="pre">runningTotal</span></code> and <code class="docutils literal"><span class="pre">amount</span></code> from the surrounding function and using them within its own function body. Capturing by reference ensures that <code class="docutils literal"><span class="pre">runningTotal</span></code> and <code class="docutils literal"><span class="pre">amount</span></code> do not disappear when the call to <code class="docutils literal"><span class="pre">makeIncrementer</span></code> ends, and also ensures that <code class="docutils literal"><span class="pre">runningTotal</span></code> is available the next time the <code class="docutils literal"><span class="pre">incrementer</span></code> function is called.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p>As an optimization, Swift may instead capture and store a <em>copy</em> of a value if that value is not mutated by a closure, and if the value is not mutated after the closure is created.</p>
<p class="last">Swift also handles all memory management involved in disposing of variables when they are no longer needed.</p>
</div>
<p>Here&rsquo;s an example of <code class="docutils literal"><span class="pre">makeIncrementer</span></code> in action:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">incrementByTen</span> = <span class="nv">makeIncrementer</span>(<span class="nv">forIncrement</span>: <span class="m">10</span>)
</li></ol></pre></div></div>
<p>This example sets a constant called <code class="docutils literal"><span class="pre">incrementByTen</span></code> to refer to an incrementer function that adds <code class="docutils literal"><span class="pre">10</span></code> to its <code class="docutils literal"><span class="pre">runningTotal</span></code> variable each time it is called. Calling the function multiple times shows this behavior in action:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">incrementByTen</span>()
</li><li><span class="c">// returns a value of 10</span>
</li><li><span class="nv">incrementByTen</span>()
</li><li><span class="c">// returns a value of 20</span>
</li><li><span class="nv">incrementByTen</span>()
</li><li><span class="c">// returns a value of 30</span>
</li></ol></pre></div></div>
<p>If you create a second incrementer, it will have its own stored reference to a new, separate <code class="docutils literal"><span class="pre">runningTotal</span></code> variable:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">incrementBySeven</span> = <span class="nv">makeIncrementer</span>(<span class="nv">forIncrement</span>: <span class="m">7</span>)
</li><li><span class="nv">incrementBySeven</span>()
</li><li><span class="c">// returns a value of 7</span>
</li></ol></pre></div></div>
<p>Calling the original incrementer (<code class="docutils literal"><span class="pre">incrementByTen</span></code>) again continues to increment its own <code class="docutils literal"><span class="pre">runningTotal</span></code> variable, and does not affect the variable captured by <code class="docutils literal"><span class="pre">incrementBySeven</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">incrementByTen</span>()
</li><li><span class="c">// returns a value of 40</span>
</li></ol></pre></div></div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">If you assign a closure to a property of a class instance, and the closure captures that instance by referring to the instance or its members, you will create a strong reference cycle between the closure and the instance. Swift uses <em>capture lists</em> to break these strong reference cycles. For more information, see <a class="reference internal" href="AutomaticReferenceCounting.html#ID56"><span class="std std-ref">Strong Reference Cycles for Closures</span></a>.</p>
</div>
</div>
<div class="section" id="ID104">
<a class="dashingAutolink" name="autolink-52"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Closures%20Are%20Reference%20Types"></a><h2>Closures Are Reference Types<a class="headerlink" href="Closures.html#ID104" title="Permalink to this headline"></a></h2>
<p>In the example above, <code class="docutils literal"><span class="pre">incrementBySeven</span></code> and <code class="docutils literal"><span class="pre">incrementByTen</span></code> are constants, but the closures these constants refer to are still able to increment the <code class="docutils literal"><span class="pre">runningTotal</span></code> variables that they have captured. This is because functions and closures are <em>reference types</em>.</p>
<p>Whenever you assign a function or a closure to a constant or a variable, you are actually setting that constant or variable to be a <em>reference</em> to the function or closure. In the example above, it is the choice of closure that <code class="docutils literal"><span class="pre">incrementByTen</span></code> <em>refers to</em> that is constant, and not the contents of the closure itself.</p>
<p>This also means that if you assign a closure to two different constants or variables, both of those constants or variables will refer to the same closure:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">alsoIncrementByTen</span> = <span class="nv">incrementByTen</span>
</li><li><span class="nv">alsoIncrementByTen</span>()
</li><li><span class="c">// returns a value of 50</span>
</li></ol></pre></div></div>
</div>
<div class="section" id="ID546">
<a class="dashingAutolink" name="autolink-53"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Escaping%20Closures"></a><h2>Escaping Closures<a class="headerlink" href="Closures.html#ID546" title="Permalink to this headline"></a></h2>
<p>A closure is said to <em>escape</em> a function when the closure is passed as an argument to the function, but is called after the function returns. When you declare a function that takes a closure as one of its parameters, you can write <code class="docutils literal"><span class="pre">@escaping</span></code> before the parameter&rsquo;s type to indicate that the closure is allowed to escape.</p>
<p>One way that a closure can escape is by being stored in a variable that is defined outside the function. As an example, many functions that start an asynchronous operation take a closure argument as a completion handler. The function returns after it starts the operation, but the closure isn&rsquo;t called until the operation is completed&mdash;the closure needs to escape, to be called later. For example:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">completionHandlers</span>: [() -&gt; <span class="nc">Void</span>] = []
</li><li><span class="k">func</span> <span class="nv">someFunctionWithEscapingClosure</span>(<span class="nv">completionHandler</span>: <span class="k">@escaping</span> () -&gt; <span class="nc">Void</span>) {
</li><li>    <span class="nv">completionHandlers</span>.<span class="nv">append</span>(<span class="nv">completionHandler</span>)
</li><li>}
</li></ol></pre></div></div>
<p>The <code class="docutils literal"><span class="pre">someFunctionWithEscapingClosure(_:)</span></code> function takes a closure as its argument and adds it to an array that&rsquo;s declared outside the function. If you didn&rsquo;t mark the parameter of this function with <code class="docutils literal"><span class="pre">@escaping</span></code>, you would get a compile-time error.</p>
<p>Marking a closure with <code class="docutils literal"><span class="pre">@escaping</span></code> means you have to refer to <code class="docutils literal"><span class="pre">self</span></code> explicitly within the closure. For example, in the code below, the closure passed to <code class="docutils literal"><span class="pre">someFunctionWithEscapingClosure(_:)</span></code> is an escaping closure, which means it needs to refer to <code class="docutils literal"><span class="pre">self</span></code> explicitly. In contrast, the closure passed to <code class="docutils literal"><span class="pre">someFunctionWithNonescapingClosure(_:)</span></code> is a nonescaping closure, which means it can refer to <code class="docutils literal"><span class="pre">self</span></code> implicitly.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">someFunctionWithNonescapingClosure</span>(<span class="nv">closure</span>: () -&gt; <span class="nc">Void</span>) {
</li><li>    <span class="nv">closure</span>()
</li><li>}
</li><li>
</li><li><span class="k">class</span> <span class="nv">SomeClass</span> {
</li><li>    <span class="k">var</span> <span class="nv">x</span> = <span class="m">10</span>
</li><li>    <span class="k">func</span> <span class="nv">doSomething</span>() {
</li><li>        <span class="nv">someFunctionWithEscapingClosure</span> { <span class="k">self</span>.<span class="nv">x</span> = <span class="m">100</span> }
</li><li>        <span class="nv">someFunctionWithNonescapingClosure</span> { <span class="nv">x</span> = <span class="m">200</span> }
</li><li>    }
</li><li>}
</li><li>
</li><li><span class="k">let</span> <span class="nv">instance</span> = <span class="nv">SomeClass</span>()
</li><li><span class="nv">instance</span>.<span class="nv">doSomething</span>()
</li><li><span class="nv">print</span>(<span class="nv">instance</span>.<span class="nv">x</span>)
</li><li><span class="c">// Prints &#34;200&#34;</span>
</li><li>
</li><li><span class="nv">completionHandlers</span>.<span class="nv">first</span>?()
</li><li><span class="nv">print</span>(<span class="nv">instance</span>.<span class="nv">x</span>)
</li><li><span class="c">// Prints &#34;100&#34;</span>
</li></ol></pre></div></div>
</div>
<div class="section" id="ID543">
<a class="dashingAutolink" name="autolink-54"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Autoclosures"></a><h2>Autoclosures<a class="headerlink" href="Closures.html#ID543" title="Permalink to this headline"></a></h2>
<p>An <em>autoclosure</em> is a closure that is automatically created to wrap an expression that&rsquo;s being passed as an argument to a function. It doesn&rsquo;t take any arguments, and when it&rsquo;s called, it returns the value of the expression that&rsquo;s wrapped inside of it. This syntactic convenience lets you omit braces around a function&rsquo;s parameter by writing a normal expression instead of an explicit closure.</p>
<p>It&rsquo;s common to <em>call</em> functions that take autoclosures, but it&rsquo;s not common to <em>implement</em> that kind of function. For example, the <code class="docutils literal"><span class="pre">assert(condition:message:file:line:)</span></code> function takes an autoclosure for its <code class="docutils literal"><span class="pre">condition</span></code> and <code class="docutils literal"><span class="pre">message</span></code> parameters; its <code class="docutils literal"><span class="pre">condition</span></code> parameter is evaluated only in debug builds and its <code class="docutils literal"><span class="pre">message</span></code> parameter is evaluated only if <code class="docutils literal"><span class="pre">condition</span></code> is <code class="docutils literal"><span class="pre">false</span></code>.</p>
<p>An autoclosure lets you delay evaluation, because the code inside isn&rsquo;t run until you call the closure. Delaying evaluation is useful for code that has side effects or is computationally expensive, because it lets you control when that code is evaluated. The code below shows how a closure delays evaluation.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">customersInLine</span> = [<span class="s">&#34;Chris&#34;</span>, <span class="s">&#34;Alex&#34;</span>, <span class="s">&#34;Ewa&#34;</span>, <span class="s">&#34;Barry&#34;</span>, <span class="s">&#34;Daniella&#34;</span>]
</li><li><span class="nv">print</span>(<span class="nv">customersInLine</span>.<span class="nv">count</span>)
</li><li><span class="c">// Prints &#34;5&#34;</span>
</li><li>
</li><li><span class="k">let</span> <span class="nv">customerProvider</span> = { <span class="nv">customersInLine</span>.<span class="nv">remove</span>(<span class="nv">at</span>: <span class="m">0</span>) }
</li><li><span class="nv">print</span>(<span class="nv">customersInLine</span>.<span class="nv">count</span>)
</li><li><span class="c">// Prints &#34;5&#34;</span>
</li><li>
</li><li><span class="nv">print</span>(<span class="s">&#34;Now serving </span>\<span class="p">(</span><span class="nv">customerProvider</span>()<span class="p">)</span><span class="s">!&#34;</span>)
</li><li><span class="c">// Prints &#34;Now serving Chris!&#34;</span>
</li><li><span class="nv">print</span>(<span class="nv">customersInLine</span>.<span class="nv">count</span>)
</li><li><span class="c">// Prints &#34;4&#34;</span>
</li></ol></pre></div></div>
<p>Even though the first element of the <code class="docutils literal"><span class="pre">customersInLine</span></code> array is removed by the code inside the closure, the array element isn&rsquo;t removed until the closure is actually called. If the closure is never called, the expression inside the closure is never evaluated, which means the array element is never removed. Note that the type of <code class="docutils literal"><span class="pre">customerProvider</span></code> is not <code class="docutils literal"><span class="pre">String</span></code> but <code class="docutils literal"><span class="pre">()</span> <span class="pre">-&gt;</span> <span class="pre">String</span></code>&mdash;a function with no parameters that returns a string.</p>
<p>You get the same behavior of delayed evaluation when you pass a closure as an argument to a function.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="c">// customersInLine is [&#34;Alex&#34;, &#34;Ewa&#34;, &#34;Barry&#34;, &#34;Daniella&#34;]</span>
</li><li><span class="k">func</span> <span class="nv">serve</span>(<span class="nv">customer</span> <span class="nv">customerProvider</span>: () -&gt; <span class="nc">String</span>) {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Now serving </span>\<span class="p">(</span><span class="nv">customerProvider</span>()<span class="p">)</span><span class="s">!&#34;</span>)
</li><li>}
</li><li><span class="nv">serve</span>(<span class="nv">customer</span>: { <span class="nv">customersInLine</span>.<span class="nv">remove</span>(<span class="nv">at</span>: <span class="m">0</span>) } )
</li><li><span class="c">// Prints &#34;Now serving Alex!&#34;</span>
</li></ol></pre></div></div>
<p>The <code class="docutils literal"><span class="pre">serve(customer:)</span></code> function in the listing above takes an explicit closure that returns a customer&rsquo;s name. The version of <code class="docutils literal"><span class="pre">serve(customer:)</span></code> below performs the same operation but, instead of taking an explicit closure, it takes an autoclosure by marking its parameter&rsquo;s type with the <code class="docutils literal"><span class="pre">@autoclosure</span></code> attribute. Now you can call the function as if it took a <code class="docutils literal"><span class="pre">String</span></code> argument instead of a closure. The argument is automatically converted to a closure, because the <code class="docutils literal"><span class="pre">customerProvider</span></code> parameter&rsquo;s type is marked with the <code class="docutils literal"><span class="pre">@autoclosure</span></code> attribute.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="c">// customersInLine is [&#34;Ewa&#34;, &#34;Barry&#34;, &#34;Daniella&#34;]</span>
</li><li><span class="k">func</span> <span class="nv">serve</span>(<span class="nv">customer</span> <span class="nv">customerProvider</span>: <span class="k">@autoclosure</span> () -&gt; <span class="nc">String</span>) {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Now serving </span>\<span class="p">(</span><span class="nv">customerProvider</span>()<span class="p">)</span><span class="s">!&#34;</span>)
</li><li>}
</li><li><span class="nv">serve</span>(<span class="nv">customer</span>: <span class="nv">customersInLine</span>.<span class="nv">remove</span>(<span class="nv">at</span>: <span class="m">0</span>))
</li><li><span class="c">// Prints &#34;Now serving Ewa!&#34;</span>
</li></ol></pre></div></div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Overusing autoclosures can make your code hard to understand. The context and function name should make it clear that evaluation is being deferred.</p>
</div>
<p>If you want an autoclosure that is allowed to escape, use both the <code class="docutils literal"><span class="pre">@autoclosure</span></code> and <code class="docutils literal"><span class="pre">@escaping</span></code> attributes. The <code class="docutils literal"><span class="pre">@escaping</span></code> attribute is described above in <a class="reference internal" href="Closures.html#ID546"><span class="std std-ref">Escaping Closures</span></a>.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="c">// customersInLine is [&#34;Barry&#34;, &#34;Daniella&#34;]</span>
</li><li><span class="k">var</span> <span class="nv">customerProviders</span>: [() -&gt; <span class="nc">String</span>] = []
</li><li><span class="k">func</span> <span class="nv">collectCustomerProviders</span>(<span class="k">_</span> <span class="nv">customerProvider</span>: <span class="k">@autoclosure</span> <span class="k">@escaping</span> () -&gt; <span class="nc">String</span>) {
</li><li>    <span class="nv">customerProviders</span>.<span class="nv">append</span>(<span class="nv">customerProvider</span>)
</li><li>}
</li><li><span class="nv">collectCustomerProviders</span>(<span class="nv">customersInLine</span>.<span class="nv">remove</span>(<span class="nv">at</span>: <span class="m">0</span>))
</li><li><span class="nv">collectCustomerProviders</span>(<span class="nv">customersInLine</span>.<span class="nv">remove</span>(<span class="nv">at</span>: <span class="m">0</span>))
</li><li>
</li><li><span class="nv">print</span>(<span class="s">&#34;Collected </span>\<span class="p">(</span><span class="nv">customerProviders</span>.<span class="nv">count</span><span class="p">)</span><span class="s"> closures.&#34;</span>)
</li><li><span class="c">// Prints &#34;Collected 2 closures.&#34;</span>
</li><li><span class="k">for</span> <span class="nv">customerProvider</span> <span class="k">in</span> <span class="nv">customerProviders</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Now serving </span>\<span class="p">(</span><span class="nv">customerProvider</span>()<span class="p">)</span><span class="s">!&#34;</span>)
</li><li>}
</li><li><span class="c">// Prints &#34;Now serving Barry!&#34;</span>
</li><li><span class="c">// Prints &#34;Now serving Daniella!&#34;</span>
</li></ol></pre></div></div>
<p>In the code above, instead of calling the closure passed to it as its <code class="docutils literal"><span class="pre">customerProvider</span></code> argument, the <code class="docutils literal"><span class="pre">collectCustomerProviders(_:)</span></code> function appends the closure to the <code class="docutils literal"><span class="pre">customerProviders</span></code> array. The array is declared outside the scope of the function, which means the closures in the array can be executed after the function returns. As a result, the value of the <code class="docutils literal"><span class="pre">customerProvider</span></code> argument must be allowed to escape the function&rsquo;s scope.</p>
</div>
</div>


    </article>
    <div class="next_previous">
        <p class="previous"><a href="Functions.html">Functions</a></p>
        <p class="next"><a href="Enumerations.html">Enumerations</a></p>
    </div>

    <div class="admonition-beta admonition">
        <p class="first admonition-title">Beta Software</p>
        <p>
          This documentation contains preliminary information about an API or technology in development.
          This information is subject to change, and software implemented according to this documentation should be tested with final operating system software.
        </p>
        <p class="last"><a class="reference external" href="https://developer.apple.com/support/beta-software/">Learn more about using Apple&#39;s beta software</a></p>
    </div>
</main>


<footer role="contentinfo">
  <aside>
    <a href="https://swift.org/atom.xml" title="Subscribe to Site Updates"><i class="feed">Subscribe</i></a>
    <a href="https://twitter.com/swiftlang" rel="nofollow" title="Follow @SwiftLang on Twitter"><i class="twitter">Twitter</i></a>
  </aside>

  <p class="copyright">Copyright &copy; 2018 Apple Inc. All rights reserved.</p>
  <p class="trademark">Swift and the Swift logo are trademarks of Apple Inc.</p>
  <p class="privacy">
    <a href="https://www.apple.com/privacy/privacy-policy/">Privacy Policy</a>
    <a href="https://www.apple.com/legal/privacy/en-ww/cookies/">Cookies</a>
  </p>
</footer>
<div id="jump_to_overlay"></div>
<script src="../_static/javascripts/application.js"></script>
  

</body></html>